/* dconf-update.c generated by valac 0.42.2, the Vala compiler
 * generated from dconf-update.vala, do not modify */

/*
 * Copyright © 2010 Codethink Limited
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the licence, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Ryan Lortie <desrt@desrt.ca>
 */


#include <glib.h>
#include <glib-object.h>
#include "../gvdb/gvdb-builder.h"
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <glib/gstdio.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GvdbItem* get_parent (GHashTable* table,
                      const gchar* name);
GSList* list_directory (const gchar* dirname,
                        mode_t mode,
                        GError** error);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
GHashTable* read_locks_directory (const gchar* dirname,
                                  GError** error);
GHashTable* read_directory (const gchar* dirname,
                            GError** error);
void maybe_update_from_directory (const gchar* dirname,
                                  GError** error);
void update_all (const gchar* dirname,
                 GError** error);
void dconf_compile (gchar** args,
                    int args_length1,
                    GError** error);
void dconf_update (gchar** args,
                   int args_length1,
                   GError** error);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 97 "dconf-update.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 121 "dconf-update.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 130 "dconf-update.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 151 "dconf-update.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 155 "dconf-update.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 161 "dconf-update.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 171 "dconf-update.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 175 "dconf-update.c"
		glong _tmp3_;
#line 1413 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 183 "dconf-update.c"
	} else {
		glong _tmp4_;
#line 1416 "glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 190 "dconf-update.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 194 "dconf-update.c"
		glong _tmp5_;
#line 1419 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 200 "dconf-update.c"
	}
#line 1421 "glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 212 "dconf-update.c"
}


GvdbItem*
get_parent (GHashTable* table,
            const gchar* name)
{
	GvdbItem* result = NULL;
	GvdbItem* parent = NULL;
	gint end = 0;
	gint _tmp5_;
	gchar* parent_name = NULL;
	gint _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gconstpointer _tmp9_;
	GvdbItem* _tmp10_;
	GvdbItem* _tmp16_;
#line 20 "../bin/dconf-update.vala"
	g_return_val_if_fail (table != NULL, NULL);
#line 20 "../bin/dconf-update.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 23 "../bin/dconf-update.vala"
	end = 0;
#line 237 "dconf-update.c"
	{
		gint i = 0;
#line 25 "../bin/dconf-update.vala"
		i = 1;
#line 242 "dconf-update.c"
		{
			gboolean _tmp0_ = FALSE;
#line 25 "../bin/dconf-update.vala"
			_tmp0_ = TRUE;
#line 25 "../bin/dconf-update.vala"
			while (TRUE) {
#line 249 "dconf-update.c"
				gint _tmp2_;
				gint _tmp3_;
#line 25 "../bin/dconf-update.vala"
				if (!_tmp0_) {
#line 254 "dconf-update.c"
					gint _tmp1_;
#line 25 "../bin/dconf-update.vala"
					_tmp1_ = i;
#line 25 "../bin/dconf-update.vala"
					i = _tmp1_ + 1;
#line 260 "dconf-update.c"
				}
#line 25 "../bin/dconf-update.vala"
				_tmp0_ = FALSE;
#line 25 "../bin/dconf-update.vala"
				_tmp2_ = i;
#line 25 "../bin/dconf-update.vala"
				if (!(string_get (name, (glong) _tmp2_) != '\0')) {
#line 25 "../bin/dconf-update.vala"
					break;
#line 270 "dconf-update.c"
				}
#line 26 "../bin/dconf-update.vala"
				_tmp3_ = i;
#line 26 "../bin/dconf-update.vala"
				if (string_get (name, (glong) (_tmp3_ - 1)) == '/') {
#line 276 "dconf-update.c"
					gint _tmp4_;
#line 27 "../bin/dconf-update.vala"
					_tmp4_ = i;
#line 27 "../bin/dconf-update.vala"
					end = _tmp4_;
#line 282 "dconf-update.c"
				}
			}
		}
	}
#line 31 "../bin/dconf-update.vala"
	_tmp5_ = end;
#line 31 "../bin/dconf-update.vala"
	_vala_assert (_tmp5_ != 0, "end != 0");
#line 33 "../bin/dconf-update.vala"
	_tmp6_ = end;
#line 33 "../bin/dconf-update.vala"
	_tmp7_ = string_substring (name, (glong) 0, (glong) _tmp6_);
#line 33 "../bin/dconf-update.vala"
	parent_name = _tmp7_;
#line 34 "../bin/dconf-update.vala"
	_tmp8_ = parent_name;
#line 34 "../bin/dconf-update.vala"
	_tmp9_ = g_hash_table_lookup (table, _tmp8_);
#line 34 "../bin/dconf-update.vala"
	parent = (GvdbItem*) _tmp9_;
#line 36 "../bin/dconf-update.vala"
	_tmp10_ = parent;
#line 36 "../bin/dconf-update.vala"
	if (_tmp10_ == NULL) {
#line 307 "dconf-update.c"
		const gchar* _tmp11_;
		GvdbItem* _tmp12_;
		GvdbItem* _tmp13_;
		const gchar* _tmp14_;
		GvdbItem* _tmp15_;
#line 37 "../bin/dconf-update.vala"
		_tmp11_ = parent_name;
#line 37 "../bin/dconf-update.vala"
		_tmp12_ = gvdb_hash_table_insert (table, _tmp11_);
#line 37 "../bin/dconf-update.vala"
		parent = _tmp12_;
#line 38 "../bin/dconf-update.vala"
		_tmp13_ = parent;
#line 38 "../bin/dconf-update.vala"
		_tmp14_ = parent_name;
#line 38 "../bin/dconf-update.vala"
		_tmp15_ = get_parent (table, _tmp14_);
#line 38 "../bin/dconf-update.vala"
		gvdb_item_set_parent (_tmp13_, _tmp15_);
#line 327 "dconf-update.c"
	}
#line 41 "../bin/dconf-update.vala"
	_tmp16_ = parent;
#line 41 "../bin/dconf-update.vala"
	result = _tmp16_;
#line 41 "../bin/dconf-update.vala"
	_g_free0 (parent_name);
#line 41 "../bin/dconf-update.vala"
	return result;
#line 337 "dconf-update.c"
}


static void
_g_free0_ (gpointer var)
{
#line 46 "../bin/dconf-update.vala"
	var = (g_free (var), NULL);
#line 346 "dconf-update.c"
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 46 "../bin/dconf-update.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 355 "dconf-update.c"
}


GSList*
list_directory (const gchar* dirname,
                mode_t mode,
                GError** error)
{
	GSList* result = NULL;
	GSList* list = NULL;
	GDir* dir = NULL;
	GDir* _tmp0_;
	const gchar* name = NULL;
	GError * _inner_error_ = NULL;
#line 44 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 45 "../bin/dconf-update.vala"
	list = NULL;
#line 46 "../bin/dconf-update.vala"
	_tmp0_ = g_dir_open (dirname, (guint) 0, &_inner_error_);
#line 46 "../bin/dconf-update.vala"
	dir = _tmp0_;
#line 46 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 46 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 46 "../bin/dconf-update.vala"
		(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
#line 46 "../bin/dconf-update.vala"
		return NULL;
#line 386 "dconf-update.c"
	}
#line 49 "../bin/dconf-update.vala"
	while (TRUE) {
#line 390 "dconf-update.c"
		GDir* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* filename = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		struct stat buf = {0};
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		struct stat _tmp9_ = {0};
		gint _tmp10_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 49 "../bin/dconf-update.vala"
		_tmp1_ = dir;
#line 49 "../bin/dconf-update.vala"
		_tmp2_ = g_dir_read_name (_tmp1_);
#line 49 "../bin/dconf-update.vala"
		name = _tmp2_;
#line 49 "../bin/dconf-update.vala"
		_tmp3_ = name;
#line 49 "../bin/dconf-update.vala"
		if (!(_tmp3_ != NULL)) {
#line 49 "../bin/dconf-update.vala"
			break;
#line 417 "dconf-update.c"
		}
#line 50 "../bin/dconf-update.vala"
		_tmp4_ = name;
#line 50 "../bin/dconf-update.vala"
		if (g_str_has_prefix (_tmp4_, ".")) {
#line 51 "../bin/dconf-update.vala"
			continue;
#line 425 "dconf-update.c"
		}
#line 54 "../bin/dconf-update.vala"
		_tmp5_ = name;
#line 54 "../bin/dconf-update.vala"
		_tmp6_ = g_build_filename (dirname, _tmp5_, NULL);
#line 54 "../bin/dconf-update.vala"
		filename = _tmp6_;
#line 58 "../bin/dconf-update.vala"
		_tmp8_ = filename;
#line 58 "../bin/dconf-update.vala"
		_tmp10_ = stat (_tmp8_, &_tmp9_);
#line 58 "../bin/dconf-update.vala"
		buf = _tmp9_;
#line 58 "../bin/dconf-update.vala"
		if (_tmp10_ < 0) {
#line 58 "../bin/dconf-update.vala"
			_tmp7_ = TRUE;
#line 443 "dconf-update.c"
		} else {
			struct stat _tmp11_;
			mode_t _tmp12_;
#line 58 "../bin/dconf-update.vala"
			_tmp11_ = buf;
#line 58 "../bin/dconf-update.vala"
			_tmp12_ = _tmp11_.st_mode;
#line 58 "../bin/dconf-update.vala"
			_tmp7_ = (_tmp12_ & S_IFMT) != mode;
#line 453 "dconf-update.c"
		}
#line 58 "../bin/dconf-update.vala"
		if (_tmp7_) {
#line 59 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 59 "../bin/dconf-update.vala"
			continue;
#line 461 "dconf-update.c"
		}
#line 62 "../bin/dconf-update.vala"
		_tmp13_ = filename;
#line 62 "../bin/dconf-update.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 62 "../bin/dconf-update.vala"
		list = g_slist_prepend (list, _tmp14_);
#line 49 "../bin/dconf-update.vala"
		_g_free0 (filename);
#line 471 "dconf-update.c"
	}
#line 65 "../bin/dconf-update.vala"
	result = list;
#line 65 "../bin/dconf-update.vala"
	_g_dir_close0 (dir);
#line 65 "../bin/dconf-update.vala"
	return result;
#line 479 "dconf-update.c"
}


GHashTable*
read_locks_directory (const gchar* dirname,
                      GError** error)
{
	GHashTable* result = NULL;
	GSList* files = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp3_;
	GSList* _tmp4_;
	GError * _inner_error_ = NULL;
#line 68 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 495 "dconf-update.c"
	{
		GSList* _tmp0_ = NULL;
		GSList* _tmp1_;
		GSList* _tmp2_;
#line 72 "../bin/dconf-update.vala"
		_tmp1_ = list_directory (dirname, S_IFREG, &_inner_error_);
#line 72 "../bin/dconf-update.vala"
		_tmp0_ = _tmp1_;
#line 72 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "../bin/dconf-update.vala"
			if (g_error_matches (_inner_error_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
#line 508 "dconf-update.c"
				goto __catch0_g_file_error_noent;
			}
			goto __finally0;
		}
#line 72 "../bin/dconf-update.vala"
		_tmp2_ = _tmp0_;
#line 72 "../bin/dconf-update.vala"
		_tmp0_ = NULL;
#line 72 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 72 "../bin/dconf-update.vala"
		files = _tmp2_;
#line 71 "../bin/dconf-update.vala"
		(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
#line 523 "dconf-update.c"
	}
	goto __finally0;
	__catch0_g_file_error_noent:
	{
		GError* e = NULL;
#line 71 "../bin/dconf-update.vala"
		e = _inner_error_;
#line 71 "../bin/dconf-update.vala"
		_inner_error_ = NULL;
#line 75 "../bin/dconf-update.vala"
		result = NULL;
#line 75 "../bin/dconf-update.vala"
		_g_error_free0 (e);
#line 75 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 75 "../bin/dconf-update.vala"
		return result;
#line 541 "dconf-update.c"
	}
	__finally0:
#line 71 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 71 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 71 "../bin/dconf-update.vala"
		return NULL;
#line 552 "dconf-update.c"
	}
#line 78 "../bin/dconf-update.vala"
	_tmp3_ = gvdb_hash_table_new (NULL, NULL);
#line 78 "../bin/dconf-update.vala"
	table = _tmp3_;
#line 80 "../bin/dconf-update.vala"
	_tmp4_ = files;
#line 560 "dconf-update.c"
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
#line 80 "../bin/dconf-update.vala"
		filename_collection = _tmp4_;
#line 80 "../bin/dconf-update.vala"
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
#line 568 "dconf-update.c"
			gchar* _tmp5_;
			gchar* filename = NULL;
#line 80 "../bin/dconf-update.vala"
			_tmp5_ = g_strdup ((const gchar*) filename_it->data);
#line 80 "../bin/dconf-update.vala"
			filename = _tmp5_;
#line 575 "dconf-update.c"
			{
				gchar* contents = NULL;
				const gchar* _tmp6_;
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
#line 82 "../bin/dconf-update.vala"
				_tmp6_ = filename;
#line 82 "../bin/dconf-update.vala"
				g_file_get_contents (_tmp6_, &_tmp7_, NULL, &_inner_error_);
#line 82 "../bin/dconf-update.vala"
				_g_free0 (contents);
#line 82 "../bin/dconf-update.vala"
				contents = _tmp7_;
#line 82 "../bin/dconf-update.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 82 "../bin/dconf-update.vala"
					g_propagate_error (error, _inner_error_);
#line 82 "../bin/dconf-update.vala"
					_g_free0 (contents);
#line 82 "../bin/dconf-update.vala"
					_g_free0 (filename);
#line 82 "../bin/dconf-update.vala"
					_g_hash_table_unref0 (table);
#line 82 "../bin/dconf-update.vala"
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 82 "../bin/dconf-update.vala"
					return NULL;
#line 605 "dconf-update.c"
				}
#line 84 "../bin/dconf-update.vala"
				_tmp8_ = contents;
#line 84 "../bin/dconf-update.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "\n", 0);
#line 611 "dconf-update.c"
				{
					gchar** line_collection = NULL;
					gint line_collection_length1 = 0;
					gint _line_collection_size_ = 0;
					gint line_it = 0;
#line 84 "../bin/dconf-update.vala"
					line_collection = _tmp10_;
#line 84 "../bin/dconf-update.vala"
					line_collection_length1 = _vala_array_length (_tmp9_);
#line 84 "../bin/dconf-update.vala"
					for (line_it = 0; line_it < _vala_array_length (_tmp9_); line_it = line_it + 1) {
#line 623 "dconf-update.c"
						gchar* _tmp11_;
						gchar* line = NULL;
#line 84 "../bin/dconf-update.vala"
						_tmp11_ = g_strdup (line_collection[line_it]);
#line 84 "../bin/dconf-update.vala"
						line = _tmp11_;
#line 630 "dconf-update.c"
						{
							const gchar* _tmp12_;
#line 85 "../bin/dconf-update.vala"
							_tmp12_ = line;
#line 85 "../bin/dconf-update.vala"
							if (g_str_has_prefix (_tmp12_, "/")) {
#line 637 "dconf-update.c"
								GHashTable* _tmp13_;
								const gchar* _tmp14_;
#line 86 "../bin/dconf-update.vala"
								_tmp13_ = table;
#line 86 "../bin/dconf-update.vala"
								_tmp14_ = line;
#line 86 "../bin/dconf-update.vala"
								gvdb_hash_table_insert_string (_tmp13_, _tmp14_, "");
#line 646 "dconf-update.c"
							}
#line 84 "../bin/dconf-update.vala"
							_g_free0 (line);
#line 650 "dconf-update.c"
						}
					}
#line 84 "../bin/dconf-update.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 655 "dconf-update.c"
				}
#line 80 "../bin/dconf-update.vala"
				_g_free0 (contents);
#line 80 "../bin/dconf-update.vala"
				_g_free0 (filename);
#line 661 "dconf-update.c"
			}
		}
	}
#line 91 "../bin/dconf-update.vala"
	result = table;
#line 91 "../bin/dconf-update.vala"
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 91 "../bin/dconf-update.vala"
	return result;
#line 671 "dconf-update.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 109 "../bin/dconf-update.vala"
	return self ? g_error_copy (self) : NULL;
#line 680 "dconf-update.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 700 "dconf-update.c"
}


GHashTable*
read_directory (const gchar* dirname,
                GError** error)
{
	GHashTable* result = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GSList* files = NULL;
	GSList* _tmp2_;
	GCompareFunc _tmp3_;
	GSList* _tmp4_;
	GHashTable* locks = NULL;
	gchar* _tmp76_;
	gchar* _tmp77_;
	GHashTable* _tmp78_;
	GHashTable* _tmp79_;
	GHashTable* _tmp80_;
	GError * _inner_error_ = NULL;
#line 94 "../bin/dconf-update.vala"
	g_return_val_if_fail (dirname != NULL, NULL);
#line 95 "../bin/dconf-update.vala"
	_tmp0_ = gvdb_hash_table_new (NULL, NULL);
#line 95 "../bin/dconf-update.vala"
	table = _tmp0_;
#line 96 "../bin/dconf-update.vala"
	_tmp1_ = table;
#line 96 "../bin/dconf-update.vala"
	gvdb_hash_table_insert (_tmp1_, "/");
#line 98 "../bin/dconf-update.vala"
	_tmp2_ = list_directory (dirname, S_IFREG, &_inner_error_);
#line 98 "../bin/dconf-update.vala"
	files = _tmp2_;
#line 98 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 98 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 98 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 98 "../bin/dconf-update.vala"
		return NULL;
#line 745 "dconf-update.c"
	}
#line 99 "../bin/dconf-update.vala"
	_tmp3_ = g_strcmp0;
#line 99 "../bin/dconf-update.vala"
	files = g_slist_sort (files, _tmp3_);
#line 100 "../bin/dconf-update.vala"
	files = g_slist_reverse (files);
#line 102 "../bin/dconf-update.vala"
	_tmp4_ = files;
#line 755 "dconf-update.c"
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
#line 102 "../bin/dconf-update.vala"
		filename_collection = _tmp4_;
#line 102 "../bin/dconf-update.vala"
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
#line 763 "dconf-update.c"
			gchar* _tmp5_;
			gchar* filename = NULL;
#line 102 "../bin/dconf-update.vala"
			_tmp5_ = g_strdup ((const gchar*) filename_it->data);
#line 102 "../bin/dconf-update.vala"
			filename = _tmp5_;
#line 770 "dconf-update.c"
			{
				GKeyFile* kf = NULL;
				GKeyFile* _tmp6_;
#line 103 "../bin/dconf-update.vala"
				_tmp6_ = g_key_file_new ();
#line 103 "../bin/dconf-update.vala"
				kf = _tmp6_;
#line 778 "dconf-update.c"
				{
					GKeyFile* _tmp7_;
					const gchar* _tmp8_;
#line 106 "../bin/dconf-update.vala"
					_tmp7_ = kf;
#line 106 "../bin/dconf-update.vala"
					_tmp8_ = filename;
#line 106 "../bin/dconf-update.vala"
					g_key_file_load_from_file (_tmp7_, _tmp8_, G_KEY_FILE_NONE, &_inner_error_);
#line 106 "../bin/dconf-update.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 790 "dconf-update.c"
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp9_;
					const gchar* _tmp10_;
					GError* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					GError* _tmp14_;
					GError* _tmp15_;
#line 105 "../bin/dconf-update.vala"
					e = _inner_error_;
#line 105 "../bin/dconf-update.vala"
					_inner_error_ = NULL;
#line 108 "../bin/dconf-update.vala"
					_tmp9_ = e;
#line 108 "../bin/dconf-update.vala"
					_tmp10_ = filename;
#line 108 "../bin/dconf-update.vala"
					_tmp11_ = e;
#line 108 "../bin/dconf-update.vala"
					_tmp12_ = _tmp11_->message;
#line 108 "../bin/dconf-update.vala"
					_tmp13_ = g_strdup_printf ("warning: Failed to read keyfile '%s': %s", _tmp10_, _tmp12_);
#line 108 "../bin/dconf-update.vala"
					_g_free0 (_tmp9_->message);
#line 108 "../bin/dconf-update.vala"
					_tmp9_->message = _tmp13_;
#line 109 "../bin/dconf-update.vala"
					_tmp14_ = e;
#line 109 "../bin/dconf-update.vala"
					_tmp15_ = _g_error_copy0 (_tmp14_);
#line 109 "../bin/dconf-update.vala"
					_inner_error_ = _tmp15_;
#line 109 "../bin/dconf-update.vala"
					_g_error_free0 (e);
#line 831 "dconf-update.c"
					goto __finally1;
				}
				__finally1:
#line 105 "../bin/dconf-update.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 105 "../bin/dconf-update.vala"
					g_propagate_error (error, _inner_error_);
#line 105 "../bin/dconf-update.vala"
					_g_key_file_unref0 (kf);
#line 105 "../bin/dconf-update.vala"
					_g_free0 (filename);
#line 105 "../bin/dconf-update.vala"
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 105 "../bin/dconf-update.vala"
					_g_hash_table_unref0 (table);
#line 105 "../bin/dconf-update.vala"
					return NULL;
#line 849 "dconf-update.c"
				}
				{
					GKeyFile* _tmp16_;
					gsize _tmp17_;
					gchar** _tmp18_;
#line 113 "../bin/dconf-update.vala"
					_tmp16_ = kf;
#line 113 "../bin/dconf-update.vala"
					_tmp18_ = g_key_file_get_groups (_tmp16_, &_tmp17_);
#line 859 "dconf-update.c"
					{
						gchar** group_collection = NULL;
						gint group_collection_length1 = 0;
						gint _group_collection_size_ = 0;
						gint group_it = 0;
#line 113 "../bin/dconf-update.vala"
						group_collection = _tmp18_;
#line 113 "../bin/dconf-update.vala"
						group_collection_length1 = _tmp17_;
#line 113 "../bin/dconf-update.vala"
						for (group_it = 0; group_it < _tmp17_; group_it = group_it + 1) {
#line 871 "dconf-update.c"
							gchar* _tmp19_;
							gchar* group = NULL;
#line 113 "../bin/dconf-update.vala"
							_tmp19_ = g_strdup (group_collection[group_it]);
#line 113 "../bin/dconf-update.vala"
							group = _tmp19_;
#line 878 "dconf-update.c"
							{
								gboolean _tmp20_ = FALSE;
								gboolean _tmp21_ = FALSE;
								const gchar* _tmp22_;
								gchar** _tmp28_ = NULL;
								GKeyFile* _tmp29_;
								const gchar* _tmp30_;
								gsize _tmp31_;
								gchar** _tmp32_;
								gint _tmp28__length1;
								gint __tmp28__size_;
#line 114 "../bin/dconf-update.vala"
								_tmp22_ = group;
#line 114 "../bin/dconf-update.vala"
								if (g_str_has_prefix (_tmp22_, "/")) {
#line 114 "../bin/dconf-update.vala"
									_tmp21_ = TRUE;
#line 896 "dconf-update.c"
								} else {
									const gchar* _tmp23_;
#line 114 "../bin/dconf-update.vala"
									_tmp23_ = group;
#line 114 "../bin/dconf-update.vala"
									_tmp21_ = g_str_has_suffix (_tmp23_, "/");
#line 903 "dconf-update.c"
								}
#line 114 "../bin/dconf-update.vala"
								if (_tmp21_) {
#line 114 "../bin/dconf-update.vala"
									_tmp20_ = TRUE;
#line 909 "dconf-update.c"
								} else {
									const gchar* _tmp24_;
#line 114 "../bin/dconf-update.vala"
									_tmp24_ = group;
#line 114 "../bin/dconf-update.vala"
									_tmp20_ = string_contains (_tmp24_, "//");
#line 916 "dconf-update.c"
								}
#line 114 "../bin/dconf-update.vala"
								if (_tmp20_) {
#line 920 "dconf-update.c"
									FILE* _tmp25_;
									const gchar* _tmp26_;
									const gchar* _tmp27_;
#line 115 "../bin/dconf-update.vala"
									_tmp25_ = stderr;
#line 115 "../bin/dconf-update.vala"
									_tmp26_ = filename;
#line 115 "../bin/dconf-update.vala"
									_tmp27_ = group;
#line 115 "../bin/dconf-update.vala"
									fprintf (_tmp25_, "%s: ignoring invalid group name: %s\n", _tmp26_, _tmp27_);
#line 116 "../bin/dconf-update.vala"
									_g_free0 (group);
#line 116 "../bin/dconf-update.vala"
									continue;
#line 936 "dconf-update.c"
								}
#line 119 "../bin/dconf-update.vala"
								_tmp29_ = kf;
#line 119 "../bin/dconf-update.vala"
								_tmp30_ = group;
#line 119 "../bin/dconf-update.vala"
								_tmp32_ = g_key_file_get_keys (_tmp29_, _tmp30_, &_tmp31_, &_inner_error_);
#line 119 "../bin/dconf-update.vala"
								_tmp28_ = _tmp32_;
#line 119 "../bin/dconf-update.vala"
								_tmp28__length1 = _tmp31_;
#line 119 "../bin/dconf-update.vala"
								__tmp28__size_ = _tmp28__length1;
#line 119 "../bin/dconf-update.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 119 "../bin/dconf-update.vala"
									_g_free0 (group);
#line 119 "../bin/dconf-update.vala"
									group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 119 "../bin/dconf-update.vala"
									if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 958 "dconf-update.c"
										goto __catch2_g_key_file_error;
									}
#line 119 "../bin/dconf-update.vala"
									_g_free0 (group);
#line 119 "../bin/dconf-update.vala"
									group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 119 "../bin/dconf-update.vala"
									_g_key_file_unref0 (kf);
#line 119 "../bin/dconf-update.vala"
									_g_free0 (filename);
#line 119 "../bin/dconf-update.vala"
									(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 119 "../bin/dconf-update.vala"
									_g_hash_table_unref0 (table);
#line 119 "../bin/dconf-update.vala"
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 119 "../bin/dconf-update.vala"
									g_clear_error (&_inner_error_);
#line 119 "../bin/dconf-update.vala"
									return NULL;
#line 979 "dconf-update.c"
								}
								{
									gchar** key_collection = NULL;
									gint key_collection_length1 = 0;
									gint _key_collection_size_ = 0;
									gint key_it = 0;
#line 119 "../bin/dconf-update.vala"
									key_collection = _tmp28_;
#line 119 "../bin/dconf-update.vala"
									key_collection_length1 = _tmp28__length1;
#line 119 "../bin/dconf-update.vala"
									for (key_it = 0; key_it < _tmp28__length1; key_it = key_it + 1) {
#line 992 "dconf-update.c"
										gchar* _tmp33_;
										gchar* key = NULL;
#line 119 "../bin/dconf-update.vala"
										_tmp33_ = g_strdup (key_collection[key_it]);
#line 119 "../bin/dconf-update.vala"
										key = _tmp33_;
#line 999 "dconf-update.c"
										{
											const gchar* _tmp34_;
											gchar* path = NULL;
											const gchar* _tmp39_;
											gchar* _tmp40_;
											gchar* _tmp41_;
											gchar* _tmp42_;
											gchar* _tmp43_;
											const gchar* _tmp44_;
											gchar* _tmp45_;
											gchar* _tmp46_;
											GHashTable* _tmp47_;
											const gchar* _tmp48_;
											gconstpointer _tmp49_;
											gchar* text = NULL;
											GKeyFile* _tmp50_;
											const gchar* _tmp51_;
											const gchar* _tmp52_;
											gchar* _tmp53_;
#line 120 "../bin/dconf-update.vala"
											_tmp34_ = key;
#line 120 "../bin/dconf-update.vala"
											if (string_contains (_tmp34_, "/")) {
#line 1023 "dconf-update.c"
												const gchar* _tmp35_;
												const gchar* _tmp36_;
												const gchar* _tmp37_;
												GError* _tmp38_;
#line 121 "../bin/dconf-update.vala"
												_tmp35_ = filename;
#line 121 "../bin/dconf-update.vala"
												_tmp36_ = group;
#line 121 "../bin/dconf-update.vala"
												_tmp37_ = key;
#line 121 "../bin/dconf-update.vala"
												_tmp38_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, "%s: [%s]: invalid key name: %s", _tmp35_, _tmp36_, _tmp37_);
#line 121 "../bin/dconf-update.vala"
												_inner_error_ = _tmp38_;
#line 121 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 121 "../bin/dconf-update.vala"
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 121 "../bin/dconf-update.vala"
												_g_free0 (group);
#line 121 "../bin/dconf-update.vala"
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 121 "../bin/dconf-update.vala"
												if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1048 "dconf-update.c"
													goto __catch2_g_key_file_error;
												}
#line 121 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 121 "../bin/dconf-update.vala"
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 121 "../bin/dconf-update.vala"
												_g_free0 (group);
#line 121 "../bin/dconf-update.vala"
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 121 "../bin/dconf-update.vala"
												_g_key_file_unref0 (kf);
#line 121 "../bin/dconf-update.vala"
												_g_free0 (filename);
#line 121 "../bin/dconf-update.vala"
												(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 121 "../bin/dconf-update.vala"
												_g_hash_table_unref0 (table);
#line 121 "../bin/dconf-update.vala"
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 121 "../bin/dconf-update.vala"
												g_clear_error (&_inner_error_);
#line 121 "../bin/dconf-update.vala"
												return NULL;
#line 1073 "dconf-update.c"
											}
#line 125 "../bin/dconf-update.vala"
											_tmp39_ = group;
#line 125 "../bin/dconf-update.vala"
											_tmp40_ = g_strconcat ("/", _tmp39_, NULL);
#line 125 "../bin/dconf-update.vala"
											_tmp41_ = _tmp40_;
#line 125 "../bin/dconf-update.vala"
											_tmp42_ = g_strconcat (_tmp41_, "/", NULL);
#line 125 "../bin/dconf-update.vala"
											_tmp43_ = _tmp42_;
#line 125 "../bin/dconf-update.vala"
											_tmp44_ = key;
#line 125 "../bin/dconf-update.vala"
											_tmp45_ = g_strconcat (_tmp43_, _tmp44_, NULL);
#line 125 "../bin/dconf-update.vala"
											_tmp46_ = _tmp45_;
#line 125 "../bin/dconf-update.vala"
											_g_free0 (_tmp43_);
#line 125 "../bin/dconf-update.vala"
											_g_free0 (_tmp41_);
#line 125 "../bin/dconf-update.vala"
											path = _tmp46_;
#line 127 "../bin/dconf-update.vala"
											_tmp47_ = table;
#line 127 "../bin/dconf-update.vala"
											_tmp48_ = path;
#line 127 "../bin/dconf-update.vala"
											_tmp49_ = g_hash_table_lookup (_tmp47_, _tmp48_);
#line 127 "../bin/dconf-update.vala"
											if (((GvdbItem*) _tmp49_) != NULL) {
#line 132 "../bin/dconf-update.vala"
												_g_free0 (path);
#line 132 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 132 "../bin/dconf-update.vala"
												continue;
#line 1111 "dconf-update.c"
											}
#line 135 "../bin/dconf-update.vala"
											_tmp50_ = kf;
#line 135 "../bin/dconf-update.vala"
											_tmp51_ = group;
#line 135 "../bin/dconf-update.vala"
											_tmp52_ = key;
#line 135 "../bin/dconf-update.vala"
											_tmp53_ = g_key_file_get_value (_tmp50_, _tmp51_, _tmp52_, &_inner_error_);
#line 135 "../bin/dconf-update.vala"
											text = _tmp53_;
#line 135 "../bin/dconf-update.vala"
											if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 135 "../bin/dconf-update.vala"
												_g_free0 (path);
#line 135 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 135 "../bin/dconf-update.vala"
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 135 "../bin/dconf-update.vala"
												_g_free0 (group);
#line 135 "../bin/dconf-update.vala"
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 135 "../bin/dconf-update.vala"
												if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1137 "dconf-update.c"
													goto __catch2_g_key_file_error;
												}
#line 135 "../bin/dconf-update.vala"
												_g_free0 (path);
#line 135 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 135 "../bin/dconf-update.vala"
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 135 "../bin/dconf-update.vala"
												_g_free0 (group);
#line 135 "../bin/dconf-update.vala"
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 135 "../bin/dconf-update.vala"
												_g_key_file_unref0 (kf);
#line 135 "../bin/dconf-update.vala"
												_g_free0 (filename);
#line 135 "../bin/dconf-update.vala"
												(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 135 "../bin/dconf-update.vala"
												_g_hash_table_unref0 (table);
#line 135 "../bin/dconf-update.vala"
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 135 "../bin/dconf-update.vala"
												g_clear_error (&_inner_error_);
#line 135 "../bin/dconf-update.vala"
												return NULL;
#line 1164 "dconf-update.c"
											}
											{
												GVariant* value = NULL;
												const gchar* _tmp54_;
												GVariant* _tmp55_;
												GvdbItem* item = NULL;
												GHashTable* _tmp56_;
												const gchar* _tmp57_;
												GvdbItem* _tmp58_;
												GvdbItem* _tmp59_;
												GHashTable* _tmp60_;
												const gchar* _tmp61_;
												GvdbItem* _tmp62_;
												GvdbItem* _tmp63_;
												GVariant* _tmp64_;
#line 138 "../bin/dconf-update.vala"
												_tmp54_ = text;
#line 138 "../bin/dconf-update.vala"
												_tmp55_ = g_variant_parse (NULL, _tmp54_, NULL, NULL, &_inner_error_);
#line 138 "../bin/dconf-update.vala"
												value = _tmp55_;
#line 138 "../bin/dconf-update.vala"
												if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 138 "../bin/dconf-update.vala"
													if (_inner_error_->domain == G_VARIANT_PARSE_ERROR) {
#line 1190 "dconf-update.c"
														goto __catch3_g_variant_parse_error;
													}
#line 138 "../bin/dconf-update.vala"
													_g_free0 (text);
#line 138 "../bin/dconf-update.vala"
													_g_free0 (path);
#line 138 "../bin/dconf-update.vala"
													_g_free0 (key);
#line 138 "../bin/dconf-update.vala"
													_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 138 "../bin/dconf-update.vala"
													_g_free0 (group);
#line 138 "../bin/dconf-update.vala"
													group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 138 "../bin/dconf-update.vala"
													_g_key_file_unref0 (kf);
#line 138 "../bin/dconf-update.vala"
													_g_free0 (filename);
#line 138 "../bin/dconf-update.vala"
													(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 138 "../bin/dconf-update.vala"
													_g_hash_table_unref0 (table);
#line 138 "../bin/dconf-update.vala"
													g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 138 "../bin/dconf-update.vala"
													g_clear_error (&_inner_error_);
#line 138 "../bin/dconf-update.vala"
													return NULL;
#line 1219 "dconf-update.c"
												}
#line 139 "../bin/dconf-update.vala"
												_tmp56_ = table;
#line 139 "../bin/dconf-update.vala"
												_tmp57_ = path;
#line 139 "../bin/dconf-update.vala"
												_tmp58_ = gvdb_hash_table_insert (_tmp56_, _tmp57_);
#line 139 "../bin/dconf-update.vala"
												item = _tmp58_;
#line 140 "../bin/dconf-update.vala"
												_tmp59_ = item;
#line 140 "../bin/dconf-update.vala"
												_tmp60_ = table;
#line 140 "../bin/dconf-update.vala"
												_tmp61_ = path;
#line 140 "../bin/dconf-update.vala"
												_tmp62_ = get_parent (_tmp60_, _tmp61_);
#line 140 "../bin/dconf-update.vala"
												gvdb_item_set_parent (_tmp59_, _tmp62_);
#line 141 "../bin/dconf-update.vala"
												_tmp63_ = item;
#line 141 "../bin/dconf-update.vala"
												_tmp64_ = value;
#line 141 "../bin/dconf-update.vala"
												gvdb_item_set_value (_tmp63_, _tmp64_);
#line 137 "../bin/dconf-update.vala"
												_g_variant_unref0 (value);
#line 1247 "dconf-update.c"
											}
											goto __finally3;
											__catch3_g_variant_parse_error:
											{
												GError* e = NULL;
												GError* _tmp65_;
												const gchar* _tmp66_;
												const gchar* _tmp67_;
												const gchar* _tmp68_;
												const gchar* _tmp69_;
												GError* _tmp70_;
												const gchar* _tmp71_;
												gchar* _tmp72_;
												GError* _tmp73_;
												GError* _tmp74_;
#line 137 "../bin/dconf-update.vala"
												e = _inner_error_;
#line 137 "../bin/dconf-update.vala"
												_inner_error_ = NULL;
#line 143 "../bin/dconf-update.vala"
												_tmp65_ = e;
#line 143 "../bin/dconf-update.vala"
												_tmp66_ = filename;
#line 143 "../bin/dconf-update.vala"
												_tmp67_ = group;
#line 143 "../bin/dconf-update.vala"
												_tmp68_ = key;
#line 143 "../bin/dconf-update.vala"
												_tmp69_ = text;
#line 143 "../bin/dconf-update.vala"
												_tmp70_ = e;
#line 143 "../bin/dconf-update.vala"
												_tmp71_ = _tmp70_->message;
#line 143 "../bin/dconf-update.vala"
												_tmp72_ = g_strdup_printf ("%s: [%s]: %s: invalid value: %s (%s)", _tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp71_);
#line 143 "../bin/dconf-update.vala"
												_g_free0 (_tmp65_->message);
#line 143 "../bin/dconf-update.vala"
												_tmp65_->message = _tmp72_;
#line 144 "../bin/dconf-update.vala"
												_tmp73_ = e;
#line 144 "../bin/dconf-update.vala"
												_tmp74_ = _g_error_copy0 (_tmp73_);
#line 144 "../bin/dconf-update.vala"
												_inner_error_ = _tmp74_;
#line 144 "../bin/dconf-update.vala"
												_g_error_free0 (e);
#line 1295 "dconf-update.c"
												goto __finally3;
											}
											__finally3:
#line 137 "../bin/dconf-update.vala"
											if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 137 "../bin/dconf-update.vala"
												_g_free0 (text);
#line 137 "../bin/dconf-update.vala"
												_g_free0 (path);
#line 137 "../bin/dconf-update.vala"
												_g_free0 (key);
#line 137 "../bin/dconf-update.vala"
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 137 "../bin/dconf-update.vala"
												_g_free0 (group);
#line 137 "../bin/dconf-update.vala"
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 137 "../bin/dconf-update.vala"
												if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1315 "dconf-update.c"
													goto __catch2_g_key_file_error;
												}
												goto __finally2;
											}
#line 119 "../bin/dconf-update.vala"
											_g_free0 (text);
#line 119 "../bin/dconf-update.vala"
											_g_free0 (path);
#line 119 "../bin/dconf-update.vala"
											_g_free0 (key);
#line 1326 "dconf-update.c"
										}
									}
								}
#line 113 "../bin/dconf-update.vala"
								_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 113 "../bin/dconf-update.vala"
								_g_free0 (group);
#line 1334 "dconf-update.c"
							}
						}
#line 113 "../bin/dconf-update.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1339 "dconf-update.c"
					}
				}
				goto __finally2;
				__catch2_g_key_file_error:
				{
					GError* e = NULL;
					const gchar* _tmp75_;
#line 112 "../bin/dconf-update.vala"
					e = _inner_error_;
#line 112 "../bin/dconf-update.vala"
					_inner_error_ = NULL;
#line 150 "../bin/dconf-update.vala"
					_tmp75_ = e->message;
#line 150 "../bin/dconf-update.vala"
					g_warning ("dconf-update.vala:150: unexpected keyfile error: %s.  Please file a bu" \
"g.", _tmp75_);
#line 151 "../bin/dconf-update.vala"
					g_assert_not_reached ();
#line 112 "../bin/dconf-update.vala"
					_g_error_free0 (e);
#line 1359 "dconf-update.c"
				}
				__finally2:
#line 112 "../bin/dconf-update.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 112 "../bin/dconf-update.vala"
					g_propagate_error (error, _inner_error_);
#line 112 "../bin/dconf-update.vala"
					_g_key_file_unref0 (kf);
#line 112 "../bin/dconf-update.vala"
					_g_free0 (filename);
#line 112 "../bin/dconf-update.vala"
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 112 "../bin/dconf-update.vala"
					_g_hash_table_unref0 (table);
#line 112 "../bin/dconf-update.vala"
					return NULL;
#line 1376 "dconf-update.c"
				}
#line 102 "../bin/dconf-update.vala"
				_g_key_file_unref0 (kf);
#line 102 "../bin/dconf-update.vala"
				_g_free0 (filename);
#line 1382 "dconf-update.c"
			}
		}
	}
#line 155 "../bin/dconf-update.vala"
	_tmp76_ = g_strconcat (dirname, "/locks", NULL);
#line 155 "../bin/dconf-update.vala"
	_tmp77_ = _tmp76_;
#line 155 "../bin/dconf-update.vala"
	_tmp78_ = read_locks_directory (_tmp77_, &_inner_error_);
#line 155 "../bin/dconf-update.vala"
	_tmp79_ = _tmp78_;
#line 155 "../bin/dconf-update.vala"
	_g_free0 (_tmp77_);
#line 155 "../bin/dconf-update.vala"
	locks = _tmp79_;
#line 155 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 155 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 155 "../bin/dconf-update.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 155 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 155 "../bin/dconf-update.vala"
		return NULL;
#line 1408 "dconf-update.c"
	}
#line 157 "../bin/dconf-update.vala"
	_tmp80_ = locks;
#line 157 "../bin/dconf-update.vala"
	if (_tmp80_ != NULL) {
#line 1414 "dconf-update.c"
		GvdbItem* item = NULL;
		GHashTable* _tmp81_;
		GvdbItem* _tmp82_;
		GvdbItem* _tmp83_;
		GHashTable* _tmp84_;
#line 158 "../bin/dconf-update.vala"
		_tmp81_ = table;
#line 158 "../bin/dconf-update.vala"
		_tmp82_ = gvdb_hash_table_insert (_tmp81_, ".locks");
#line 158 "../bin/dconf-update.vala"
		item = _tmp82_;
#line 159 "../bin/dconf-update.vala"
		_tmp83_ = item;
#line 159 "../bin/dconf-update.vala"
		_tmp84_ = locks;
#line 159 "../bin/dconf-update.vala"
		gvdb_item_set_hash_table (_tmp83_, _tmp84_);
#line 1432 "dconf-update.c"
	}
#line 162 "../bin/dconf-update.vala"
	result = table;
#line 162 "../bin/dconf-update.vala"
	_g_hash_table_unref0 (locks);
#line 162 "../bin/dconf-update.vala"
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 162 "../bin/dconf-update.vala"
	return result;
#line 1442 "dconf-update.c"
}


void
maybe_update_from_directory (const gchar* dirname,
                             GError** error)
{
	struct stat dir_buf = {0};
	gboolean _tmp0_ = FALSE;
	struct stat _tmp1_ = {0};
	gint _tmp2_;
	GError * _inner_error_ = NULL;
#line 165 "../bin/dconf-update.vala"
	g_return_if_fail (dirname != NULL);
#line 168 "../bin/dconf-update.vala"
	_tmp2_ = stat (dirname, &_tmp1_);
#line 168 "../bin/dconf-update.vala"
	dir_buf = _tmp1_;
#line 168 "../bin/dconf-update.vala"
	if (_tmp2_ == 0) {
#line 1463 "dconf-update.c"
		struct stat _tmp3_;
		mode_t _tmp4_;
#line 168 "../bin/dconf-update.vala"
		_tmp3_ = dir_buf;
#line 168 "../bin/dconf-update.vala"
		_tmp4_ = _tmp3_.st_mode;
#line 168 "../bin/dconf-update.vala"
		_tmp0_ = S_ISDIR (_tmp4_);
#line 1472 "dconf-update.c"
	} else {
#line 168 "../bin/dconf-update.vala"
		_tmp0_ = FALSE;
#line 1476 "dconf-update.c"
	}
#line 168 "../bin/dconf-update.vala"
	if (_tmp0_) {
#line 1480 "dconf-update.c"
		struct stat lockdir_buf = {0};
		struct stat file_buf = {0};
		gchar* filename = NULL;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gchar* _tmp9_;
		gchar* _tmp10_;
		struct stat _tmp11_ = {0};
		gint _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp20_ = FALSE;
		const gchar* _tmp21_;
		struct stat _tmp22_ = {0};
		gint _tmp23_;
		GHashTable* table = NULL;
		GHashTable* _tmp28_;
		gint fd = 0;
		const gchar* _tmp29_;
		gboolean _tmp30_ = FALSE;
		gint _tmp31_;
#line 172 "../bin/dconf-update.vala"
		_tmp5_ = strlen (dirname);
#line 172 "../bin/dconf-update.vala"
		_tmp6_ = _tmp5_;
#line 172 "../bin/dconf-update.vala"
		_tmp7_ = string_substring (dirname, (glong) 0, (glong) (_tmp6_ - 2));
#line 172 "../bin/dconf-update.vala"
		filename = _tmp7_;
#line 174 "../bin/dconf-update.vala"
		_tmp9_ = g_strconcat (dirname, "/locks", NULL);
#line 174 "../bin/dconf-update.vala"
		_tmp10_ = _tmp9_;
#line 174 "../bin/dconf-update.vala"
		_tmp12_ = stat (_tmp10_, &_tmp11_);
#line 174 "../bin/dconf-update.vala"
		lockdir_buf = _tmp11_;
#line 174 "../bin/dconf-update.vala"
		_tmp13_ = _tmp12_ == 0;
#line 174 "../bin/dconf-update.vala"
		_g_free0 (_tmp10_);
#line 174 "../bin/dconf-update.vala"
		if (_tmp13_) {
#line 1525 "dconf-update.c"
			struct stat _tmp14_;
			time_t _tmp15_;
			struct stat _tmp16_;
			time_t _tmp17_;
#line 174 "../bin/dconf-update.vala"
			_tmp14_ = lockdir_buf;
#line 174 "../bin/dconf-update.vala"
			_tmp15_ = _tmp14_.st_mtime;
#line 174 "../bin/dconf-update.vala"
			_tmp16_ = dir_buf;
#line 174 "../bin/dconf-update.vala"
			_tmp17_ = _tmp16_.st_mtime;
#line 174 "../bin/dconf-update.vala"
			_tmp8_ = _tmp15_ > _tmp17_;
#line 1540 "dconf-update.c"
		} else {
#line 174 "../bin/dconf-update.vala"
			_tmp8_ = FALSE;
#line 1544 "dconf-update.c"
		}
#line 174 "../bin/dconf-update.vala"
		if (_tmp8_) {
#line 1548 "dconf-update.c"
			struct stat _tmp18_;
			time_t _tmp19_;
#line 176 "../bin/dconf-update.vala"
			_tmp18_ = lockdir_buf;
#line 176 "../bin/dconf-update.vala"
			_tmp19_ = _tmp18_.st_mtime;
#line 176 "../bin/dconf-update.vala"
			dir_buf.st_mtime = _tmp19_;
#line 1557 "dconf-update.c"
		}
#line 179 "../bin/dconf-update.vala"
		_tmp21_ = filename;
#line 179 "../bin/dconf-update.vala"
		_tmp23_ = stat (_tmp21_, &_tmp22_);
#line 179 "../bin/dconf-update.vala"
		file_buf = _tmp22_;
#line 179 "../bin/dconf-update.vala"
		if (_tmp23_ == 0) {
#line 1567 "dconf-update.c"
			struct stat _tmp24_;
			time_t _tmp25_;
			struct stat _tmp26_;
			time_t _tmp27_;
#line 179 "../bin/dconf-update.vala"
			_tmp24_ = file_buf;
#line 179 "../bin/dconf-update.vala"
			_tmp25_ = _tmp24_.st_mtime;
#line 179 "../bin/dconf-update.vala"
			_tmp26_ = dir_buf;
#line 179 "../bin/dconf-update.vala"
			_tmp27_ = _tmp26_.st_mtime;
#line 179 "../bin/dconf-update.vala"
			_tmp20_ = _tmp25_ > _tmp27_;
#line 1582 "dconf-update.c"
		} else {
#line 179 "../bin/dconf-update.vala"
			_tmp20_ = FALSE;
#line 1586 "dconf-update.c"
		}
#line 179 "../bin/dconf-update.vala"
		if (_tmp20_) {
#line 180 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 180 "../bin/dconf-update.vala"
			return;
#line 1594 "dconf-update.c"
		}
#line 183 "../bin/dconf-update.vala"
		_tmp28_ = read_directory (dirname, &_inner_error_);
#line 183 "../bin/dconf-update.vala"
		table = _tmp28_;
#line 183 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 183 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 183 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 183 "../bin/dconf-update.vala"
			return;
#line 1608 "dconf-update.c"
		}
#line 185 "../bin/dconf-update.vala"
		_tmp29_ = filename;
#line 185 "../bin/dconf-update.vala"
		fd = open (_tmp29_, O_WRONLY, (mode_t) 0);
#line 187 "../bin/dconf-update.vala"
		_tmp31_ = fd;
#line 187 "../bin/dconf-update.vala"
		if (_tmp31_ < 0) {
#line 1618 "dconf-update.c"
			gint _tmp32_;
#line 187 "../bin/dconf-update.vala"
			_tmp32_ = errno;
#line 187 "../bin/dconf-update.vala"
			_tmp30_ = _tmp32_ != ENOENT;
#line 1624 "dconf-update.c"
		} else {
#line 187 "../bin/dconf-update.vala"
			_tmp30_ = FALSE;
#line 1628 "dconf-update.c"
		}
#line 187 "../bin/dconf-update.vala"
		if (_tmp30_) {
#line 1632 "dconf-update.c"
			gint saved_error = 0;
			gint _tmp33_;
			const gchar* _tmp34_;
			gint _tmp35_;
			const gchar* _tmp36_;
#line 188 "../bin/dconf-update.vala"
			_tmp33_ = errno;
#line 188 "../bin/dconf-update.vala"
			saved_error = _tmp33_;
#line 189 "../bin/dconf-update.vala"
			_tmp34_ = filename;
#line 189 "../bin/dconf-update.vala"
			_tmp35_ = saved_error;
#line 189 "../bin/dconf-update.vala"
			_tmp36_ = g_strerror (_tmp35_);
#line 189 "../bin/dconf-update.vala"
			g_printerr ("warning: Failed to open '%s' for replacement: %s\n", _tmp34_, _tmp36_);
#line 190 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 190 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 190 "../bin/dconf-update.vala"
			return;
#line 1656 "dconf-update.c"
		}
		{
			GHashTable* _tmp37_;
			const gchar* _tmp38_;
			gint _tmp39_;
#line 196 "../bin/dconf-update.vala"
			_tmp37_ = table;
#line 196 "../bin/dconf-update.vala"
			_tmp38_ = filename;
#line 196 "../bin/dconf-update.vala"
			gvdb_table_write_contents (_tmp37_, _tmp38_, FALSE, &_inner_error_);
#line 196 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1670 "dconf-update.c"
				goto __catch4_g_error;
			}
#line 198 "../bin/dconf-update.vala"
			_tmp39_ = fd;
#line 198 "../bin/dconf-update.vala"
			if (_tmp39_ >= 0) {
#line 1677 "dconf-update.c"
				gint _tmp40_;
#line 199 "../bin/dconf-update.vala"
				_tmp40_ = fd;
#line 199 "../bin/dconf-update.vala"
				write (_tmp40_, "\0\0\0\0\0\0\0\0", (gsize) 8);
#line 1683 "dconf-update.c"
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 195 "../bin/dconf-update.vala"
			e = _inner_error_;
#line 195 "../bin/dconf-update.vala"
			_inner_error_ = NULL;
#line 202 "../bin/dconf-update.vala"
			_tmp41_ = e;
#line 202 "../bin/dconf-update.vala"
			_tmp42_ = _tmp41_->message;
#line 202 "../bin/dconf-update.vala"
			g_printerr ("warning: %s\n", _tmp42_);
#line 203 "../bin/dconf-update.vala"
			_g_error_free0 (e);
#line 1704 "dconf-update.c"
			{
				gint _tmp43_;
#line 205 "../bin/dconf-update.vala"
				_tmp43_ = fd;
#line 205 "../bin/dconf-update.vala"
				if (_tmp43_ >= 0) {
#line 1711 "dconf-update.c"
					gint _tmp44_;
#line 206 "../bin/dconf-update.vala"
					_tmp44_ = fd;
#line 206 "../bin/dconf-update.vala"
					close (_tmp44_);
#line 1717 "dconf-update.c"
				}
			}
#line 203 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 203 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 203 "../bin/dconf-update.vala"
			return;
#line 1726 "dconf-update.c"
		}
		__finally4:
		{
			gint _tmp45_;
#line 205 "../bin/dconf-update.vala"
			_tmp45_ = fd;
#line 205 "../bin/dconf-update.vala"
			if (_tmp45_ >= 0) {
#line 1735 "dconf-update.c"
				gint _tmp46_;
#line 206 "../bin/dconf-update.vala"
				_tmp46_ = fd;
#line 206 "../bin/dconf-update.vala"
				close (_tmp46_);
#line 1741 "dconf-update.c"
			}
		}
#line 195 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 195 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 195 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 195 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 195 "../bin/dconf-update.vala"
			return;
#line 1754 "dconf-update.c"
		}
		{
			GDBusConnection* system_bus = NULL;
			GDBusConnection* _tmp47_;
			GDBusConnection* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			GVariant* _tmp54_;
			GVariant* _tmp55_;
			GDBusConnection* _tmp56_;
#line 211 "../bin/dconf-update.vala"
			_tmp47_ = g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, &_inner_error_);
#line 211 "../bin/dconf-update.vala"
			system_bus = _tmp47_;
#line 211 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1774 "dconf-update.c"
				goto __catch5_g_error;
			}
#line 212 "../bin/dconf-update.vala"
			_tmp48_ = system_bus;
#line 212 "../bin/dconf-update.vala"
			_tmp49_ = filename;
#line 212 "../bin/dconf-update.vala"
			_tmp50_ = g_path_get_basename (_tmp49_);
#line 212 "../bin/dconf-update.vala"
			_tmp51_ = _tmp50_;
#line 212 "../bin/dconf-update.vala"
			_tmp52_ = g_strconcat ("/ca/desrt/dconf/Writer/", _tmp51_, NULL);
#line 212 "../bin/dconf-update.vala"
			_tmp53_ = _tmp52_;
#line 212 "../bin/dconf-update.vala"
			_tmp54_ = g_variant_new ("(s)", "/", NULL);
#line 212 "../bin/dconf-update.vala"
			g_variant_ref_sink (_tmp54_);
#line 212 "../bin/dconf-update.vala"
			_tmp55_ = _tmp54_;
#line 212 "../bin/dconf-update.vala"
			g_dbus_connection_emit_signal (_tmp48_, NULL, _tmp53_, "ca.desrt.dconf.Writer", "WritabilityNotify", _tmp55_, &_inner_error_);
#line 212 "../bin/dconf-update.vala"
			_g_variant_unref0 (_tmp55_);
#line 212 "../bin/dconf-update.vala"
			_g_free0 (_tmp53_);
#line 212 "../bin/dconf-update.vala"
			_g_free0 (_tmp51_);
#line 212 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 212 "../bin/dconf-update.vala"
				_g_object_unref0 (system_bus);
#line 1807 "dconf-update.c"
				goto __catch5_g_error;
			}
#line 214 "../bin/dconf-update.vala"
			_tmp56_ = system_bus;
#line 214 "../bin/dconf-update.vala"
			g_dbus_connection_flush_sync (_tmp56_, NULL, &_inner_error_);
#line 214 "../bin/dconf-update.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 214 "../bin/dconf-update.vala"
				_g_object_unref0 (system_bus);
#line 1818 "dconf-update.c"
				goto __catch5_g_error;
			}
#line 210 "../bin/dconf-update.vala"
			_g_object_unref0 (system_bus);
#line 1823 "dconf-update.c"
		}
		goto __finally5;
		__catch5_g_error:
		{
#line 210 "../bin/dconf-update.vala"
			g_clear_error (&_inner_error_);
#line 210 "../bin/dconf-update.vala"
			_inner_error_ = NULL;
#line 1832 "dconf-update.c"
		}
		__finally5:
#line 210 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 210 "../bin/dconf-update.vala"
			g_propagate_error (error, _inner_error_);
#line 210 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 210 "../bin/dconf-update.vala"
			_g_free0 (filename);
#line 210 "../bin/dconf-update.vala"
			return;
#line 1845 "dconf-update.c"
		}
#line 168 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 168 "../bin/dconf-update.vala"
		_g_free0 (filename);
#line 1851 "dconf-update.c"
	}
}


void
update_all (const gchar* dirname,
            GError** error)
{
	GSList* _tmp0_ = NULL;
	GSList* _tmp1_;
	GError * _inner_error_ = NULL;
#line 221 "../bin/dconf-update.vala"
	g_return_if_fail (dirname != NULL);
#line 222 "../bin/dconf-update.vala"
	_tmp1_ = list_directory (dirname, S_IFDIR, &_inner_error_);
#line 222 "../bin/dconf-update.vala"
	_tmp0_ = _tmp1_;
#line 222 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 222 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 222 "../bin/dconf-update.vala"
		return;
#line 1875 "dconf-update.c"
	}
	{
		GSList* name_collection = NULL;
		GSList* name_it = NULL;
#line 222 "../bin/dconf-update.vala"
		name_collection = _tmp0_;
#line 222 "../bin/dconf-update.vala"
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 1884 "dconf-update.c"
			gchar* _tmp2_;
			gchar* name = NULL;
#line 222 "../bin/dconf-update.vala"
			_tmp2_ = g_strdup ((const gchar*) name_it->data);
#line 222 "../bin/dconf-update.vala"
			name = _tmp2_;
#line 1891 "dconf-update.c"
			{
				const gchar* _tmp3_;
#line 223 "../bin/dconf-update.vala"
				_tmp3_ = name;
#line 223 "../bin/dconf-update.vala"
				if (g_str_has_suffix (_tmp3_, ".d")) {
#line 1898 "dconf-update.c"
					{
						const gchar* _tmp4_;
#line 225 "../bin/dconf-update.vala"
						_tmp4_ = name;
#line 225 "../bin/dconf-update.vala"
						maybe_update_from_directory (_tmp4_, &_inner_error_);
#line 225 "../bin/dconf-update.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1907 "dconf-update.c"
							goto __catch6_g_error;
						}
					}
					goto __finally6;
					__catch6_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp5_;
						GError* _tmp6_;
						const gchar* _tmp7_;
#line 224 "../bin/dconf-update.vala"
						e = _inner_error_;
#line 224 "../bin/dconf-update.vala"
						_inner_error_ = NULL;
#line 227 "../bin/dconf-update.vala"
						_tmp5_ = name;
#line 227 "../bin/dconf-update.vala"
						_tmp6_ = e;
#line 227 "../bin/dconf-update.vala"
						_tmp7_ = _tmp6_->message;
#line 227 "../bin/dconf-update.vala"
						g_printerr ("unable to compile %s: %s\n", _tmp5_, _tmp7_);
#line 224 "../bin/dconf-update.vala"
						_g_error_free0 (e);
#line 1932 "dconf-update.c"
					}
					__finally6:
#line 224 "../bin/dconf-update.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 224 "../bin/dconf-update.vala"
						g_propagate_error (error, _inner_error_);
#line 224 "../bin/dconf-update.vala"
						_g_free0 (name);
#line 224 "../bin/dconf-update.vala"
						(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
#line 224 "../bin/dconf-update.vala"
						return;
#line 1945 "dconf-update.c"
					}
				}
#line 222 "../bin/dconf-update.vala"
				_g_free0 (name);
#line 1950 "dconf-update.c"
			}
		}
	}
#line 221 "../bin/dconf-update.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
#line 1956 "dconf-update.c"
}


void
dconf_compile (gchar** args,
               int args_length1,
               GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 234 "../bin/dconf-update.vala"
	_tmp2_ = args[2];
#line 234 "../bin/dconf-update.vala"
	if (_tmp2_ == NULL) {
#line 234 "../bin/dconf-update.vala"
		_tmp1_ = TRUE;
#line 1975 "dconf-update.c"
	} else {
		const gchar* _tmp3_;
#line 234 "../bin/dconf-update.vala"
		_tmp3_ = args[3];
#line 234 "../bin/dconf-update.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1982 "dconf-update.c"
	}
#line 234 "../bin/dconf-update.vala"
	if (_tmp1_) {
#line 234 "../bin/dconf-update.vala"
		_tmp0_ = TRUE;
#line 1988 "dconf-update.c"
	} else {
		const gchar* _tmp4_;
#line 234 "../bin/dconf-update.vala"
		_tmp4_ = args[4];
#line 234 "../bin/dconf-update.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1995 "dconf-update.c"
	}
#line 234 "../bin/dconf-update.vala"
	if (_tmp0_) {
#line 1999 "dconf-update.c"
		GError* _tmp5_;
#line 235 "../bin/dconf-update.vala"
		_tmp5_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "must give output file and .d dir");
#line 235 "../bin/dconf-update.vala"
		_inner_error_ = _tmp5_;
#line 235 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 235 "../bin/dconf-update.vala"
		return;
#line 2009 "dconf-update.c"
	}
	{
		GHashTable* table = NULL;
		const gchar* _tmp6_;
		GHashTable* _tmp7_;
		gboolean should_byteswap = FALSE;
		GHashTable* _tmp8_;
		const gchar* _tmp9_;
		gboolean _tmp10_;
#line 241 "../bin/dconf-update.vala"
		_tmp6_ = args[3];
#line 241 "../bin/dconf-update.vala"
		_tmp7_ = read_directory (_tmp6_, &_inner_error_);
#line 241 "../bin/dconf-update.vala"
		table = _tmp7_;
#line 241 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2027 "dconf-update.c"
			goto __catch7_g_error;
		}
#line 242 "../bin/dconf-update.vala"
		should_byteswap = G_BYTE_ORDER == G_BIG_ENDIAN;
#line 243 "../bin/dconf-update.vala"
		_tmp8_ = table;
#line 243 "../bin/dconf-update.vala"
		_tmp9_ = args[2];
#line 243 "../bin/dconf-update.vala"
		_tmp10_ = should_byteswap;
#line 243 "../bin/dconf-update.vala"
		gvdb_table_write_contents (_tmp8_, _tmp9_, _tmp10_, &_inner_error_);
#line 243 "../bin/dconf-update.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 243 "../bin/dconf-update.vala"
			_g_hash_table_unref0 (table);
#line 2044 "dconf-update.c"
			goto __catch7_g_error;
		}
#line 238 "../bin/dconf-update.vala"
		_g_hash_table_unref0 (table);
#line 2049 "dconf-update.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp11_;
#line 238 "../bin/dconf-update.vala"
		e = _inner_error_;
#line 238 "../bin/dconf-update.vala"
		_inner_error_ = NULL;
#line 245 "../bin/dconf-update.vala"
		_tmp11_ = e->message;
#line 245 "../bin/dconf-update.vala"
		g_printerr ("%s\n", _tmp11_);
#line 246 "../bin/dconf-update.vala"
		exit (1);
#line 238 "../bin/dconf-update.vala"
		_g_error_free0 (e);
#line 2068 "dconf-update.c"
	}
	__finally7:
#line 238 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 238 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 238 "../bin/dconf-update.vala"
		return;
#line 2077 "dconf-update.c"
	}
}


void
dconf_update (gchar** args,
              int args_length1,
              GError** error)
{
	GError * _inner_error_ = NULL;
#line 254 "../bin/dconf-update.vala"
	update_all (SYSCONFDIR "/dconf/db", &_inner_error_);
#line 254 "../bin/dconf-update.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 254 "../bin/dconf-update.vala"
		g_propagate_error (error, _inner_error_);
#line 254 "../bin/dconf-update.vala"
		return;
#line 2096 "dconf-update.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



